/*
 * IBM Confidential
 * OCO Source Materials
 * Component IBM Rational ROSE_RT BUILD : ROSE_RT
 * (c) Copyright IBM Corp. [1998], [2004] .All Rights Reserved.
 * 
 * The source code for this program is not published or
 * or otherwise divested of its trade secrets, irrespective
 * of what has been deposited with the U.S. Copyright Office.
 * 
 * 
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 * 
 */

#ifndef __RTPubl_Main_h__
#define __RTPubl_Main_h__ included

#include <RTPubl/SystDesc.h>
#include <RTPubl/UMLRT.h>
#include <RTPubl/RSL.h>

#if USE_THREADS
struct _RTMutex;
struct _RTThread;
#endif

struct _RTController;

typedef enum _RTMain_state
{
    RTMain_initializing,
    RTMain_executing,
    RTMain_shuttingDown
} RTMain_state;

/*
    The RTMain structure is not meant to be accessed directly.
    Please use the supported API calls to access attributes of
    RTMain.
*/

typedef struct _RTMain
{
    const RTSystemDescriptor  * theSystem;
    int                         argc;
    const char * const        * argv;
    struct _RTController     ** controllers;
    RTMain_state                state;

#if USE_THREADS
    int                         startupCountdown;
    struct _RTThread         ** threads;
    struct _RTMutex           * mutex;

#if OTRTSDEBUG != DEBUG_NONE
    struct _RTThread          * debugThread;
#endif /* OTRTSDEBUG != DEBUG_NONE */
#endif /* USE_THREADS */
} RTMain;

/* public (supported) api for user code */

int                     RTMain_argc( void );
const char * const    * RTMain_argv( void );
int                     RTMain_numberOfThreads( void );
struct _RTController ** RTMain_controllers( void );

/* private (unsupported) api for user code */

const RTSystemDescriptor * RTMain_system( void );
RTMain                   * RTMain_soleInstance( void );
struct _RTController     * RTMain_controller( void );
void                       RTMain_controllerStarted( void );

int  RTMain_execute( const RTSystemDescriptor *,
		     int                        argc,
		     const char * const       * argv );
int  RTMain_entryPoint( int argc, const char * const * argv );

int  RTMain_runThread( void );
int  RTMain_mainLine ( void );

void RTMain_installOneHandler( int, void (*)( void ) );
void RTMain_installHandlers( void );

void RTMain_startup( void );
void RTMain_shutdown( void );

void RTMain_exit( int );

#endif /* __RTPubl_Main_h__ */
