#
# Note:
#   Before using this module, make sure that the PIPC.pm
#   module is located in one of the @INC directories.
#


use PIPC;

package MwxdeClient; 
@ISA = qw( PIPC );


# Extended PIPC codes
my $PIPC_CUSTM = PIPC->GetPtlCustomCodeRange();
my $PIPC_TITLE = $PIPC_CUSTM + 1;  # Title code
my $PIPC_IFCNT = $PIPC_CUSTM + 2;  # Item count code
my $PIPC_ITEXT = $PIPC_CUSTM + 3;  # Item text code



sub new {
    my $class = shift;
    my $self = new PIPC;
    bless $self;
    return $self;
}


sub PrintItem {
    my $self = shift;
    $self->PIPC::SendMessage( $PIPC_ITEXT, shift );
}


sub PrintTitle {
    my $self = shift;
    $self->PIPC::SendMessage( $PIPC_IFCNT, shift );
    $self->PIPC::SendMessage( $PIPC_TITLE, shift );
}


1; # Must return TRUE to satisfy the compiler
