#########################################################################
#                                                                       #
#  This program is the CONFIDENTIAL and PROPRIETARY property            #
#  of Mainsoft(R) Corporation. Any unauthorized use, reproduction       #
#  or transfer of this computer program is strictly prohibited.         #
#                                                                       #
#  Copyright (c) 1991-1998 Mainsoft Corporation.                        #
#  This is an unpublished work, and is subject to limited distribution  #
#  and restricted disclosure only. ALL RIGHTS RESERVED.                 #
#                                                                       #
#########################################################################


package PPService;

require "PrintEx.pl";


sub new {
    my $class = shift;
    my $self = {};

    $self->{bGUIMode} = shift;
    if( $self->{bGUIMode} ) {
	use MwxdeClient;
	$self->{mwxdeClient} = new MwxdeClient;
	$self->{mwxdeClient}->EnableTracing( shift );
	$self->{mwxdeClient}->Connect();
    }

    bless $self;
}


sub DESTROY {
    my $self = shift;
    $self->{mwxdeClient}->Disconnect();
}
    

sub PrintItem {
    my $self = shift;

    if( $self->{bGUIMode} ) {	
	$self->{mwxdeClient}->PrintItem( shift );
    } else {
	print "   @_\n";
    }
}


sub PrintTitle {
    my $self = shift;

    if( $self->{bGUIMode} ) {
	$self->{mwxdeClient}->PrintTitle( shift, shift );
    } else {
	PrintEx( "\n\n" . $_[ @_ > 1 ? 1 : 0 ] . "\n\n", $WM_BOLD | $WM_UNDERLINE );
    }
}


sub PrintError {
    my $self = shift;

    if( $self->{bGUIMode} ) {
	$self->{mwxdeClient}->PrintError( shift );
    }
    else {
	PrintEx( "\a\nError: ", $WM_BOLD, $OS_STDERR );
	PrintEx( "$_[0]\n\n", 0, $OS_STDERR );
    }
}


1;
