# This is a -*- perl -*- script

#########################################################################
#                                                                       #
#  This program is the CONFIDENTIAL and PROPRIETARY property            #
#  of Mainsoft(R) Corporation. Any unauthorized use, reproduction       #
#  or transfer of this computer program is strictly prohibited.         #
#                                                                       #
#  Copyright (c) 1991-1998 Mainsoft Corporation.                        #
#  This is an unpublished work, and is subject to limited distribution  #
#  and restricted disclosure only. ALL RIGHTS RESERVED.                 #
#                                                                       #
#########################################################################

# Perl 'print' function with extended capabilities. 
# Supports bold, underline and reverse write modes.
# 


# -- output streams --
$OS_STDOUT    = 1;
$OS_STDERR    = 2;

# -- write modes --
$WM_BOLD      = 1;
$WM_UNDERLINE = 2;
$WM_REVERSE   = 4;


sub PrintEx {
    return if !@_;

    my( $strMode ) = "";
    my( $string, $nMode, $nStream ) = @_;

    if( @_ > 1 ) {
	$strMode .= "\e[1m" if( $nMode & $WM_BOLD );
	$strMode .= "\e[4m" if( $nMode & $WM_UNDERLINE );
	$strMode .= "\e[7m" if( $nMode & $WM_REVERSE );
    }

    if( $nMode ) {
	PrintStream( "$strMode$string\e[0m", $nStream );
    }
    else {
	PrintStream( $string, $nStream );
    }
}


sub PrintStream {
    my( $string, $nStream ) = @_;

    print STDOUT $string if( !defined( $nStream ) || ( $nStream & $OS_STDOUT ) );
    print STDERR $string if( defined( $nStream ) && ( $nStream & $OS_STDERR ) );
}

