# This is a perl script
##########################################################################
#    This program is the CONFIDENTIAL and PROPRIETARY property
#    of Mainsoft(R) Corporation. Any unauthorized use, reproduction 
#    or transfer of this computer program is strictly prohibited.
#
#    Copyright (c) 1991-1998 Mainsoft Corporation.
#    This is an unpublished work, and is subject to limited distribution
#    and restricted disclosure only. ALL RIGHTS RESERVED.
#
##########################################################################

my $bAutoLoad = 0;


if( $ARGV[0] eq "-autoload" ) {
    shift @ARGV;
    $bAutoLoad = 1;
    ChangeMessageMap( @ARGV );
}


sub AUTOLOAD {
    print "      Uncknown function $AUTOLOAD called at line ".__LINE__.".\n";
    print "      Defaulting to ChangeMessageMap().\n";
    ChangeMessageMap( @_ );
}


sub ChangeMessageMap {
    my $derivedDefined=0;

    while ($file= pop(@_)) {
	next if ((! -f $file) || (-l $file));
	%unixfilename = ( 'strstrea', 'strstream' );
	
	print STDOUT "Updating MFC maps for $file\n" if $bAutoLoad;
	open(FROM_FILE,"<$file");
	open(TO_FILE,">$file.out");
      LINE:
	while(<FROM_FILE>) 
	{
	    if (/^[ \t]*#define theDerivedClass/) {
		next LINE;
	    }
	    if (/^[ \t]*#undef theDerivedClass/) {
		next LINE;
	    }
	    #if (/^[ \t]*\/\/\{\{AFX_MSG_MAP/) {

	    # do not define theDerivedClass if there is not base class
	    # it is the case for ATL maps
	    if (/^[ \t]*BEGIN_\w+\_MAP/ && /\((.*),([ \t]*)(.*)\)/)  {
		$derivedDefined=1;
		$ClassName=$1;
		print TO_FILE "#define theDerivedClass ${ClassName} ::\n";
		print TO_FILE $_;
		&process_message_map ($1);
	    } elsif (/^[ \t]*END_\w+\_MAP/) {
		print TO_FILE $_;
		print TO_FILE "#undef theDerivedClass\n" if $derivedDefined;
		$derivedDefined=0;
	    } else {
		print TO_FILE $_;
	    }
	}
	close (FROM_FILE);
	close (TO_FILE);
	if( ! -z "$file.out" ) {
	    if( 0 == system( "diff $file $file.out > /dev/null" ) ) {
		unlink( "$file.out" );
	    }
	    else {
		rename( "$file.out", "$file" );
	    }
	}
	else {
	    print STDERR "Update failed: couldn't create file of size " . ( -s $file ) . ". Please check your disk space.\n\n";
	    unlink( "$file.out" );
	}
    }
}


sub process_message_map {
    local($ClassName) = shift(@_);
    local($alreadyUnDefed) = 0;
    local($alreadyDefed) = 1;
    local($emptyDefed) = 0;
while(<FROM_FILE>) {
	# discard any entries that we may have
	# created in a previous run
	if (/^[ \t]*#define theDerivedClass/) {
	    next;
	}
	if (/^[ \t]*#undef theDerivedClass/) {
	    next;
	}
# 	if (/\s*ON_\w+\(.+,\s*\w+::.+\)/) {
 	if (/\s*(ON_|DISP_)\w+\(.+,.+::.+\)/) {
	    if ($alreadyUnDefed == 1) {
		print TO_FILE $_;
	    } else {
		# we have a fully qualified method name.
		# we don't want to end up with class::class::member
		# so we undef theDerivedClass, define it to the
		# empty string, and continue
		if ($emptyDefed == 0) {
		    print TO_FILE "#undef theDerivedClass\n";
		    print TO_FILE "#define theDerivedClass\n";
		}
		print TO_FILE $_;
		$alreadyUnDefed = 1;
		$emptyDefed = 1;
	    }
	} elsif (/^[ \t]*END_\w+\_MAP/) {
	    print TO_FILE $_;
	    print TO_FILE "#undef theDerivedClass\n";
	    return;
	} elsif (/\s*(ON_|DISP_)\w+\((.+,\s*\w+\)|(.*))/) {
	    if ($emptyDefed == 1) {
		# if have have already defed this to
		# the empty string, undef it to prevent
		# needless warnings
		print TO_FILE "#undef theDerivedClass\n";
		$alreadyUndefed = 0;
		$alreadyDefed = 0;
		$emptyDefed = 0;
	    }
	    if ($alreadyDefed == 0) {
		print TO_FILE "#define theDerivedClass ${ClassName} :: \n";
	    }
	    print TO_FILE $_;
	    $alreadyUnDefed = 0;
	    $alreadyDefed = 1;
	} else {
	    print TO_FILE $_;
	}
    }
}


1;  # to satisfy the 'require' function
