# This is a perl script

# transform a list of exported functions (as produced by GetFunctions) into
# the format suitable for the target architecture linker


##########################################################################
#    This program is the CONFIDENTIAL and PROPRIETARY property
#    of Mainsoft(R) Corporation. Any unauthorized use, reproduction 
#    or transfer of this computer program is strictly prohibited.
#
#    Copyright (c) 1991-1998 Mainsoft Corporation.
#    This is an unpublished work, and is subject to limited distribution
#    and restricted disclosure only. ALL RIGHTS RESERVED.
#
##########################################################################
if (@ARGV != 0 && @ARGV != 1) {  
  printf STDERR "usage: mwconvertexports [<cflags>] < infile > outfile\n";
  exit 1;
}

$MWARCH_OS = $ENV{'MWARCH_OS'};
$MWOS      = $ENV{'MWOS'};
$MWARCH    = $ENV{'MWARCH'};
$MWTECHNO  = $ENV{'MWTECHNO'};
$MWHOME    = $ENV{'MWHOME'};

local(@decls);

if (@ARGV == 1) {
    $cflags = shift(@ARGV);
    $tagstart = "<====-~-~ the real exports start here ~-~-~-====>";
    $tagend = "<====-~-~ the real exports end here ~-~-~-====>";

    ## first preprocess the input file in order to do the correct replacements
    ## defined in windows.h

    $tmpfile1 = "convert1-$$.tmp";
    $tmpfile2 = "convert2-$$.tmp";
    open (CPP,">${tmpfile1}");
    print CPP "#include <windows.h>\n";
    print CPP "${tagstart}\n";
    while (<>) {
        print CPP; }
    print CPP "${tagend}\n";
    close (CPP);
    system("mwcpp ${cflags} ${tmpfile1} > ${tmpfile2}");
    open (TMP, "<${tmpfile2}");
    while (<TMP>) {
	last if /${tagstart}/;
    }

    while (<TMP>) {
        last if /${tagend}/;
        if ((! /^\s*#/o) && (! /^\s*$/o)) {
	    chop;
	    push(@decls,$_);
        }
    }
    close (TMP);
    unlink ($tmpfile1);
    unlink ($tmpfile2);
} else {
    ## $cflags not passed => dont preprocess
    while (<>) {
        if ((! /^\s*#/o) && (! /^\s*$/o)) {
	    chop;
	    push(@decls,$_);
        }
    }
}
   
if (("$MWOS" eq "ux9") || ("$MWOS" eq "ux10")) {
   foreach $_ (@decls) {
	print "+e $_\n";
   }
} else {
   foreach $_ (@decls) {
	print "$_\n";
   }
}

