# This is a perl script
##########################################################################
#    This program is the CONFIDENTIAL and PROPRIETARY property
#    of Mainsoft(R) Corporation. Any unauthorized use, reproduction 
#    or transfer of this computer program is strictly prohibited.
#
#    Copyright (c) 1991-1998 Mainsoft Corporation.
#    This is an unpublished work, and is subject to limited distribution
#    and restricted disclosure only. ALL RIGHTS ESERVED.
#
##########################################################################

my $bAutoLoad = 0;
my @declarable_things = (
    'DYNAMIC',
    'DYNCREATE',
    'SERIAL',
    'OLECREATE',
    'OLETYPELIB',
    'OLECREATE_EX',
    'OLECTLTYPE',
    'PROPPAGEIDS'
);


if( $ARGV[0] eq "-autoload" ) {
    shift @ARGV;
    $bAutoLoad = 1;
    FixNonStdCtors( @ARGV );
}


sub AUTOLOAD {
    print "      Uncknown function $AUTOLOAD called at line ".__LINE__.".\n";
    print "      Defaulting to FixNonStdCtors.\n";
    FixNonStdCtors( @_ );
}


sub FixNonStdCtors {
    while ($file= pop(@_)) {
	next if ((! -f $file) || (-l $file));
	
	open(FROM_FILE,"<$file");
	open(TO_FILE,">$file.out");
	$was_modified = 0;
	while(<FROM_FILE>) {
	    if (/DECLARE_(.*)\(.*\) *; *$/) {
		if(grep($_ eq $1 ,@declarable_things)) {
		    s/;//;
		    $was_modified = 1;
		}
	    }
	    print TO_FILE $_;
	}
	close (FROM_FILE);
	close (TO_FILE);
	if($was_modified){
	    if( ! -z "$file.out" ) {
		rename( "$file.out", "$file" );
		print STDOUT "Fixed nonstandard C++ constructs in $file\n" if $bAutoLoad;
	    }
	    else {
		print STDERR "Fix failed: couldn't create file of size " . ( -s $file ) . ". Please check your disk space.\n\n";
		unlink( "$file.out" );
	    }
	}
	else {
	    unlink("$file.out");
	}
    }
}


1;  # to satisfy the 'require' function
    
