



   # This is a -*- perl -*- script

#########################################################################
#                                                                       #
#  This program is the CONFIDENTIAL and PROPRIETARY property            #
#  of Mainsoft(R) Corporation. Any unauthorized use, reproduction       #
#  or transfer of this computer program is strictly prohibited.         #
#                                                                       #
#  Copyright (c) 1991-1998 Mainsoft Corporation.                        #
#  This is an unpublished work, and is subject to limited distribution  #
#  and restricted disclosure only. ALL RIGHTS RESERVED.                 #
#                                                                       #
#########################################################################


require "$ENV{'MWHOME'}/lib/common-utilities.pl";
require "$ENV{'MWHOME'}/lib/PrintEx.pl";


# -- module types --
$MT_EXE = 1;
$MT_DLL = 2;
$MT_LIB = 3;

# -- support type --
$ST_MFC = 1;
$ST_OLE = 2;
$ST_ATL = 4;

$nModuleType;
$nSupportType;
$bMfcExtDll;
$bOcxControl;
$bConsoleApp;
$ModuleName;

$bJustDemo;
$bJustCompile;
$bGenComments;
$bRecursive;
$bGUIMode;

$MwClearmake;
$MkFilename;
@PROJECTDIR;
$ProjectDir  = defined( $ENV{ USER_SRC_DIR } ) ? $ENV{ USER_SRC_DIR } : ".";

$bSkipMkDepend;
$bEnableTracing = 0;
$sFileName;
$bUseMidlGenFiles;


main();



# ------ functions ------ #

sub main {
    InitGlobals();
    chdir( $ProjectDir );
    chomp( $ProjectDir = `pwd` );  # get full path of current directory
    CheckPermissions();
    ReadProjectDir();

    if( $ENV{ CLEARCASE_ROOT } ne "" ) {
	$MwClearmake = 1;
	$MkFilename = "GNUmakefile";
    }

    if( !ProcessArgs() ) {
	$bGUIMode = 1;
	$MkFilename = "/dev/null/$MkFilename";   # only untill prj info is functioned out
    }

    TRACE( "[MOD SUP DLL OCX CON NAME] = [ $nModuleType $nSupportType $bMfcExtDll $bOcxControl $bConsoleApp $ModuleName ]" );

    if( -f $MkFilename ) {
	printf "\a$MkFilename is already present in the directory \e[1m$ProjectDir\e[0m.\nPlease remove or rename it prior to executing mwgenmake again.\n";
	exit( -1 );
    }

    if( scalar( grep( /(\.c$)|(\.C$)|(\.cxx$)|(\.cpp$)/, @PROJECTDIR ) ) ) { 
	CreateSourceMakefile() unless $bJustDemo;
	CreateDemoFile();		    
    } 
    elsif( $bRecursive ) {
	CreateRecDirectoryMakefile();
    }
    else {
	print "No source files found in the directory \e[1m$ProjectDir\e[0m. Exiting.\n";
	exit( -1 );
    }
    
    TRACE( "[MOD SUP DLL OCX CON NAME] = [ $nModuleType $nSupportType $bMfcExtDll $bOcxControl $bConsoleApp $ModuleName ]" );

    if( $bGUIMode ) {
	$bMfcExtDll = 0 unless defined $bMfcExtDll;
	$bOcxControl = 0 unless defined $bOcxControl;
	$bConsoleApp = 0 unless defined $bConsoleApp;

	TRACE( "[MOD SUP DLL OCX CON NAME] = [ $nModuleType $nSupportType $bMfcExtDll $bOcxControl $bConsoleApp $ModuleName ]" );

	exec( "mwxde -defs $nModuleType$nSupportType$bMfcExtDll$bOcxControl$bConsoleApp$ModuleName" );
    }
}


sub CreateDirectoryMakefile {
    my $dir;
    my @DIRS;

    if( ( @DIRS = grep( (!/^\.$/) && (!/^\.\.$/) && (!/CVS/) && (-d $_), @PROJECTDIR ) ) ) {
	open(MK,">$MkFilename");
	PrintComment( "This makefile was generated automatically by mwgenmake." );
	printf MK "\nworld all clean install depend:\n";
	foreach $dir (@DIRS) {
	    printf MK "\t(cd $dir; \$\{MAKE\} \$\{MFLAGS\} \$\@)\n";
	}
	close (MK);
    } 
    else {
	printf( "\nThere are no subdirectories under %s", `pwd` );
	print "No makefile generated\n";
	exit( -1 );
    }
}


sub CreateRecDirectoryMakefile {
    my $cd;
    my $dir;
    my @DIRS;

    @DIRS = grep( (!/^.$/) && (!/^..$/) && (-d $_), @PROJECTDIR );

    TRACE( "CreateRecDirectoryMakefile: @PROJECTDIR\n\n" );
    open( MK,">$MkFilename" );
    printf MK "all:\n";
    foreach $dir( @DIRS ) {
	printf MK "\t-(cd $dir;\$\{MAKE\})\n";
    }
    close( MK );

    open( DEM,">demo" );
    printf DEM "#!/bin/sh\n";
    foreach $dir( @DIRS ) {
	printf DEM "\t-(cd $dir;demo)\n";
    }
    close( DEM );
    chmod 0771,"demo";
    foreach $dir( @DIRS ) {
	push( @ARGV, "-rec" );
	chop( $cd = `pwd` );
	chdir( $dir );
	main();
	chdir $cd;
    }
}


sub CreateSourceMakefile {
    my @RCFILES;
    my @MCFILES;
    my $r_script;
    my $r_count;

    system( "rm -R obj run 2>/dev/null" );
		
    ParseDefFile() unless defined( $bMfcExtDll ) || $bConsoleApp;
    $nModuleType = $MT_EXE unless $nModuleType;
    DetectModuleName() unless defined( $ModuleName );

    @RCFILES = grep( /\.rc$/, @PROJECTDIR );
    $r_script = "$ModuleName.rc";
    $r_count = 1;
    if( !( -f "$ModuleName.rc" ) && @RCFILES ) {
        $r_count = @RCFILES;
        if ($r_count > 0) {
            $r_script = @RCFILES[0];
        }
        if ($r_count > 1) {
            printf "WARNING: There are more then one .rc files, the first one ${r_script} taken\n";
        }
    }
    @MCFILES = grep( /\.mc$/, @PROJECTDIR );

    open( MK, ">$MkFilename" );
	
    AppendGeneralCommentsSection();
    AppendSourceSection();

    if( $bJustCompile ) {
	printf MK "COMPILE      = ${ModuleName}"; PrintComment( "to compile but not to link", '@' ); print MK "\n";
	printf MK "COMPILEOBJS := \$\{SOURCES:%%.C=%%.o\}\n";
	printf MK "COMPILEOBJS := \$\{COMPILEOBJS:%%.cpp=%%.o\}\n";
	printf MK "COMPILEOBJS := \$\{COMPILEOBJS:%%.cxx=%%.o\}\n";
	printf MK "COMPILEOBJS := \$\{COMPILEOBJS:%%.c=%%.o\}\n";
    } 
    elsif( $nModuleType == $MT_LIB ) {
	printf MK "WLIB	 = ${ModuleName}\n";
	printf MK "LIB	 = lib\$\{WLIB\}.a"; PrintComment( "target static library", '@' ); print MK "\n";
	printf MK "LIBOBJS := \$\{SOURCES:%%.C=%%.o\}\n";
	printf MK "LIBOBJS := \$\{LIBOBJS:%%.cpp=%%.o\}\n";
	printf MK "LIBOBJS := \$\{LIBOBJS:%%.cxx=%%.o\}\n";
	printf MK "LIBOBJS := \$\{LIBOBJS:%%.c=%%.o\}\n";
    } 
    elsif( $nModuleType == $MT_EXE ) {
	printf MK "PROG	  = ${ModuleName}\n\n";
	printf MK "CPP_OBJS  = \$\{SOURCES:%%.C=%%.o\}\n";
	printf MK "CPP_OBJS := \$\{CPP_OBJS:%%.cpp=%%.o\}\n";
	printf MK "CPP_OBJS := \$\{CPP_OBJS:%%.cxx=%%.o\}\n";
	printf MK "OBJS	  = \$\{CPP_OBJS:%%.c=%%.o\}\n";
    } 
    else {  # $nModuleType == $MT_DLL
	PrintComment( "Original Windows DLL name and target unix shared library" );
	printf MK "WDLL      = $ModuleName\n";	
	if( $bOcxControl ) {
	    printf MK "DLL       = \$\{WDLL\}.ocx\n\n";
	} else {
	    printf MK "DLL       = lib\$\{WDLL\}.\$\{MW_SHARED_LIBRARY_SUFFIX\}\n\n";
	}

	printf MK "CPP_OBJS  = \$\{SOURCES:%%.C=%%.o\}\n";
	printf MK "CPP_OBJS := \$\{CPP_OBJS:%%.cpp=%%.o\}\n";
	printf MK "CPP_OBJS := \$\{CPP_OBJS:%%.cxx=%%.o\}\n";
	printf MK "DLLOBJS   = \$\{CPP_OBJS:%%.c=%%.o\}\n";
    }				    

    printf MK "SRCS      = \$\{SOURCES\}\n\n";

    if($r_count > 0 && @RCFILES && ( $nModuleType != $MT_LIB ) && !$bJustCompile ) {
	print MK "WRESOURCE = ${r_script}"; PrintComment( "Windows resource", '@' );
	print MK "RRESOURCE = \$\{", ( $nModuleType == $MT_EXE ) ? "PROG" : "WDLL", "\}.rsb"; 
	PrintComment( "Target X resource (must match " . ( $nModuleType == $MT_EXE ) ? "program" : "DLL" . "name)", '@' );
	print MK "\n";
    }

    if ( @MCFILES  && ( $nModuleType != $MT_LIB ) && !$bJustCompile ) {
        print MK "MESSAGES.file = @MCFILES\n";
        print MK "\n";
    }

    PrintComment( "COMPILE_OPTION can be one of the following: debug, optimized" );
    print MK "ifndef COMPILE_OPTION\n";	
    print MK "COMPILE_OPTION = debug\n";
    print MK "endif\n\n";


    AppendMidlSection();
    AppendConsoleSection() if( $bConsoleApp );
    AppendLinkSection() unless $nModuleType == $MT_LIB;

    if( $nSupportType & $ST_ATL ) {
	print MK "# Tell the generic makefiles that this is an ATL module.\n";
	print MK "ATL_MODULE = 1\n";
	print MK "\n";
	print MK "# by default a minsize server is generated \n";
	print MK "# if you want a standalone server aka one that doesn't need alt.dll\n";
	print MK "# specify the ATL_MINDEPENDENCIES flag\n";
	print MK "# ATL_MINDEPENDENCIES  = 1\n";

    }

    if( $nSupportType & $ST_MFC ) {
	my $strMfcModType;
	SWITCH: {
	    if( $nModuleType == $MT_EXE ) {
		$strMfcModType = "EXE";
		last SWITCH;
	    }
	    if( $nModuleType == $MT_LIB ) {
		$strMfcModType = "LIB";
		last SWITCH;
	    }
	    # default ( $nModuleType == $MT_DLL )
	    $strMfcModType = $bMfcExtDll ? "EXTENSION_DLL" : "DLL";
	    last SWITCH;
	}		
	
	PrintComment( 
	    "MFC library related definitions.",
	    "Removing these definitions disables linking with MFC.",
	    "MFC_MODULE_TYPE can be one of the following: DLL, EXTENSION_DLL, EXE, LIB"
	);
    	printf MK "MFC_MODULE_TYPE=$strMfcModType\n";
    	printf MK "MFC_LIB_ROOT=mfc400\n\n";
    }
    printf MK "include \$(MWHOME)/make.rules.simple\n\n";

    printf MK "ifeq (\${MW_CLEARMAKE},no)\n";
    printf MK "include \$(DEPEND_FILE)\n";
    printf MK "endif\n\n";

    if( $bOcxControl || ($nSupportType & $ST_ATL) ) {
	if( $nModuleType == $MT_DLL ) {
	    printf MK "all:\tregister_dll\n";
	}
	else {
	    printf MK "all:\tregister_exe\n";
	}
    }

    close( MK );

    if( !$MwClearmake && !$bGUIMode ) {
        system( "touch depend-\${MWCONFIG_NAME}" );
        system( "mwmake -f $MkFilename depend" ) unless $bSkipMkDepend;
    }
}


sub CheckPermissions {
    if( ! -w "." ) {
	PrintEx( "\n\aFatal error:\n", $WM_BOLD );
	print "   The current directory does not appear to be writable.\n";
	print "   Please check its permission mode.\n\n";
	exit( -1 );
    }
}


sub ReadProjectDir {
    opendir( DIR, $ProjectDir );
    @PROJECTDIR = sort readdir( DIR );
    closedir( DIR );
}


#
# Processes command line arguments. Returns 0 if no arguments
# were passed or only '-t' (enables  tracing) was specified.
#
sub ProcessArgs {
    # DEC Perl 5.x BUG:
    # The scalar value of an empty @ARGV is always equal or greater than 1.
    return 0 if( !@ARGV || ( @ARGV == 1 && $ARGV[0] eq "" ) );

    if( @ARGV == 1 && $ARGV[0] eq "-t" ) {
	$bEnableTracing = 1;
	return 0;
    }

    while( $opt = shift( @ARGV ) ) {
	next if( CheckModuleType( $opt ) );
	next if( CheckSupportType( $opt ) );
	next if( CheckExtensions( $opt ) );

	SWITCH: {
	    if( $opt eq "-demo" ) {
		# print "Creating just demo file...\n";
		$bJustDemo = 1;
		last SWITCH;
	    } 
	    if( $opt eq "-compile" ) {
		# print "Creating makefile with rules just for compiling...\n";
		$bJustCompile = 1;
		last SWITCH;
	    }
	    if( $opt eq "-dir" ) {
		# print "Creating a directory only makefile...\n";
		CreateDirectoryMakefile();
		exit( 0 );
	    }
	    if( $opt eq "-rec" ) {
		$bRecursive = 1;
		last SWITCH;
	    }
	    if( $opt eq "-nocmts" ) {
		$bGenComments = 0;
		last SWITCH;
	    }
	    if( ( $opt eq "-help" ) || ( $opt eq "-h" ) ) {
		DisplayUsage();
		last SWITCH;
	    }
	    if( $opt eq "-t" ) {
		$bEnableTracing = 1;
		last SWITCH;
	    }
	    if( $opt eq "-out" ) {
		$sFileName = shift( @ARGV );
		if($sFileName !~ /^-/) { 
		 $MkFilename = $sFileName;
		}
		else {
	       	    unshift( @ARGV );
		}	
		last SWITCH;
	    }
	    if( $opt eq "-nogui" || $opt eq "-" ) {
		# just to prevent the use of mwxde
		last SWITCH;
	    }
	    if( $opt eq "-nomkdepend" ) {
		# This option should be used in the GUI mode to prevent 'make depend'
		# invocation before the user gets a chance to edit the newly generated makefile.
		$bSkipMkDepend = 1;
		last SWITCH;
	    }
	    if( $opt eq "-use_idl_files" ) {
		$bUseMidlGenFiles = 1;
		last SWITCH;
	    }
	    if( $opt =~ /^-/ ) {
		Abort( "Invalid option '$opt'." );
		last SWITCH;
	    }

            # default - must be a module name
	    $ModuleName = $opt;
	}
    }
    VerifyArgsCompatibility();

    return 1;
}


sub CheckModuleType {
    my $mt = 0;
    my $arg = shift;

    if( $arg eq "-exe" ) {
	$mt = $MT_EXE;
    } elsif( $arg eq "-dll" ) {
	$mt = $MT_DLL;
    } elsif( $arg eq "-lib" ) {
	$mt = $MT_LIB;
    }

    if( $mt ) {
	if( !$nModuleType || ( $nModuleType == $mt ) ) {
	    $nModuleType = $mt;
	    return 1;
	} 
	else {
	    Abort( "Ambiguous module type." );
	}
    }
    else {  # $mt == 0
	return 0;
    }
}


sub CheckSupportType {
    my $st = 0;
    my $arg = shift;

    if( $arg eq "-mfc" ) {
	$st |= $ST_MFC;
    } 
    elsif( $arg eq "-ole") {
	$st |= $ST_OLE;
    } 
    elsif( $arg eq "-atl" ) {
	$st |= $ST_ATL + $ST_OLE;
    }

    if( $st ) {
	$nSupportType |= $st;
	return 1;
    }
    else {
	return 0;
    }
}


sub CheckExtensions {
    my $arg = shift;

    if( $arg eq "-ext" ) {
	$bMfcExtDll = 1;
	$nSupportType |= $ST_MFC;
    }
    elsif( $arg eq "-ocx" ) {
	$bOcxControl = 1;
	$nSupportType |= $ST_OLE;
    }
    elsif( $arg eq "-con" ) {
	$bConsoleApp = 1;
    }
    else {
	return 0;
    }

    return 1;
}


#
# Verifies the compatibility of the command line arguments.
#
sub VerifyArgsCompatibility {
    if( $bConsoleApp && ( ( $nModuleType > $MT_EXE ) || $bMfcExtDll || $bOcxControl ) ) {
	Abort( "Ambiguous module type: flag '-con' is only compatible with '-exe'" );
    }

    if( $bOcxControl || $bMfcExtDll ) {
	if( !$nModuleType ) {
	    $nModuleType = $MT_DLL;
	}
	elsif( $nModuleType != $MT_DLL ) {
	    Abort( "Ambiguous module type: flags '-ext' and '-ocx' are only compatible with '-dll'" );
	}
    }
}


#
# Performs first stage module name detection (a very approximate one).
# A more precise detection should follow in DetectSupportType, during def file
# processing (if any), and hopefully, in .mak / .dsp (DevStudio project file) 
# parsing (If and when I get to write it).
#
sub DetectModuleName {
    my $dir;
    my $theRcFile = GetFirstFile( "rc" );

    TRACE( "DetectModuleName: RC file = $theRcFile" );
    if( defined( $theRcFile ) ) {
	$theRcFile =~ /(.*)\./;
	$ModuleName = $1;
    }
    else {
	chop( $dir = `pwd` );
	$dir =~ /.*\/([^\/]+)$/;
	$ModuleName = $1 if $ModuleName eq "";
    }
}


#
# Attempts to detect the support (MFC/OLE/ATL) needed for current project.
# This type of detection is absolutely autonomous, i.e. capable of parsing
# the available project source files in order to retrieve the required
# information. Yet it's relatively limited, time-consuming and imprecise.
# Therefore the preferred detection mechanism should be MSDEV makefile /
# project file parsing.
#
sub DetectSupportType {
    my $stdafx_present = scalar( grep( /(S|s)td(A|a)fx\./, @PROJECTDIR ) );
    my $atl_files_present = scalar( grep( /(\.idl)|(\.odl)/, @PROJECTDIR ) );

    $nSupportType |= $ST_ATL if $atl_files_present;
}


sub ParseDefFile {
    my $bGuessDllType = !$nModuleType;
    my $theDefFile = GetFirstFile( "def" );
    my $pat = "\\s*\"*([a-zA-Z0-9_]+)\"*";

    TRACE( "ParseDefFile: DEF File = $theDefFile" );
    return 0 unless defined( $theDefFile );

    open( DEF, "<$theDefFile" );
    while( <DEF> ) {
	$line = "\L$_";
	if( ( $line =~ /^\s*name$pat/ ) && ( !$nModuleType || $nModuleType == $MT_EXE ) ) {
	    $ModuleName = $1 unless defined( $ModuleName );
	    $nModuleType = $MT_EXE;
	}
	if( ( $line =~ /^\s*library$pat/ ) && ( !$nModuleType || $nModuleType == $MT_DLL ) ) {
	    $ModuleName = $1 unless defined( $ModuleName );
	    $nModuleType = $MT_DLL;
	    $bOcxControl = 1 if( $line =~ /\.ocx/ );
	}
    }
    if( $bGuessDllType && 
       ( $nModuleType == $MT_DLL ) && 
       ( $nSupportType & $ST_MFC ) && 
       !defined( $bMfcExtDll ) ) 
    {
	do "$MWLIB/getmfc_dll_type";
	$bMfcExtDll = ( getmfc_dll_type() eq "extension" ) ? 1 : 0;
    }
    return 1;
}


sub Abort {
    PrintEx( "\nError: ", $WM_BOLD );
    PrintEx( "\a$_[0]\n\n", $WM_UNDERLINE );
    DisplayUsage();
}


sub CreateDemoFile {
    if( $nModuleType == $MT_EXE ) {
	open( DEM, ">demo" );
	printf DEM "#!/bin/sh\n";
	printf DEM "a=\$*\n";
	printf DEM "exec run/\${MWCONFIG_NAME}/$ModuleName \$a\n";
	close( DEM );
	chmod 0770,"demo";
    }
}


sub AppendGeneralCommentsSection {
    return unless $bGenComments;

    printf MK "## This makefile has been generated automatically by mwgenmake.\n\n";
    printf MK "## You may define the following variables:\n";
    printf MK "## RUN.dir         : the directory where you want the executables to go\n";
    printf MK "## COMPILE_OPTION  : can have the values: debug, optimized\n";
    printf MK "## APP_CFLAGS      : additional compilation flags for C compiler\n";
    printf MK "##                   and Resource compiler\n";
    printf MK "## APP_CCPPFLAGS   : additional compilation flags for C++ compiler\n";
    if( $nModuleType == $MT_DLL ) {
	printf MK "## APP_DLLFLAGS    : additional link flags\n";
    } else {
	printf MK "## APP_LDFLAGS     : additional link flags (maybe specifying DLLs)\n";
    }
    printf MK "## APP_RCFLAGS     : additional flags for resource compiler\n";
    printf MK "## MWINIT_DEFINES  : list of -D<symbols> used to initialize\n";
    printf MK "##                   Mainwin in certain specific ways \n";
    printf MK "## MWLOCALES       : list of country codes corresponding to the\n";
    printf MK "##                   resources you have prepared in the res subdirectory\n";
    printf MK "## MIDL_IDL        : The IDL file to be compiled with MIDL\n";
    printf MK "## MIDL_IID        : The iid file from MIDL (default: <idl_name>_i.c)\n";
    printf MK "## MIDL_PROXY      : The proxy implementation from MIDL (default: <idl_name>_p.c)\n";
    printf MK "## MIDL_HEADER     : The header with the interfaces and GUIDs (default: <idl_name>.h)\n";
    printf MK "## MIDL_DLLDATA    : The dll data for the proxy from MIDL (default: dlldata.c)\n";
    printf MK "## MIDL_TLB        : The typelib information from MIDL (default: <idl_name>.tlb)\n";
    printf MK "##                   this will be created in the {RUN.dir} directory.\n";
    printf MK "## MESSAGES.file   : The .mc file to be used as input for the message compiler\n";
    printf MK "## MESSAGES.hdir   : The output directory for message compiler generated headers\n";
    printf MK "## MESSAGES.rdir   : The output directory for message compiler generated resources\n";
    printf MK "## MESSAGES.flags  : Additional flags for the message compiler\n\n\n";
}


sub DisplayUsage {
    PrintEx( "\nSynopsis\n\n", $WM_BOLD | $WM_UNDERLINE );
    print "   mwgenmake [module] [ { -exe [-con] } | -dll | -lib ] [-mfc] [-ole] [-atl] [ -ext | -ocx ] [-nogui] [-nocmts] |\n";
    print "             [ -demo | { -compile [-nocmts] } | -dir | -rec ] [-out filename] |\n";
    print "             [ -use_idl_files ] | [ -help ]\n\n\n";

    PrintEx( "Options and operands\n\n", $WM_BOLD | $WM_UNDERLINE );
    print "   module         Specifies module name. Omit the operand to let mwgenmake provide one.\n\n";

    print "   -demo          Generate only a demo file.\n";
    print "   -compile       Generate a makefile to compile but not link the objects.\n";
    print "   -rec           Generate a makefile in all subdirectories.\n";
    print "   -dir           Generate a makefile that calls makefiles in subdirectories.\n\n";

    print "   -exe           Generate a makefile for an executable module.\n";
    print "   -lib           Generate a makefile for a static link library.\n";
    print "   -dll           Generate a makefile for a dynamic link library.\n";
    print "   -con           Generate a makefile for a console application.\n";
    print "   -mfc           Add MFC support.\n";
    print "   -ole           Add OLE support.\n";
    print "   -atl           Add ATL support.\n";
    print "   -ext           Generate a makefile for an MFC extension DLL.\n";
    print "   -ocx           Generate a makefile for an ActiveX control (implicitly adds OLE support).\n\n";

    print "   -nogui         Surpress mwgenmake interactive mode.\n";
    print "   -nocmts        Do not generate makefile comments.\n";
    print "   -out fname     Generate a makefile named 'fname'.\n";
    print "   -use_idl_files Use midl generated files.\n";
    print "   -help          Display this message.\n\n\n";

    PrintEx( "Description\n\n", $WM_BOLD | $WM_UNDERLINE );
    print "   mwgenmake automates generating MainWin project makefile.\n";
    print "   If no switches are specified, mwgenmake runs in interactive mode.\n";
    print "   Unless specified explicitly, required options will be determined\n";
    print "   automatically by mwgenmake.\n\n\n";

    PrintEx( "Examples\n\n", $WM_BOLD | $WM_UNDERLINE );
    print "   mwgenmake -exe -mfc          Generate a makefile for an executable with MFC support\n";
    print "   mwgenmake -dll -mfc -ext     Generate a makefile for an MFC extended DLL\n";
    print "   mwgenmake -ext               Same as above\n";
    print "   mwgenmake -lib               Generate a makefile for a static-link library\n";
    print "   mwgenmake -out mymakefile    Generate a makefile name 'mymakefile'\n";
    print "\n\n";
    exit( -1 );
}



#
# Returns first file of the specified type (extension)
# in the project directory.
#
sub GetFirstFile {
    my $FileType = shift;
    my @FILES = grep( /\.${FileType}$/, @PROJECTDIR );
    return $FILES[ 0 ];
}


sub TRACE {
    if( $bEnableTracing ) {
	print "\e[1mTRACE:\e[0m $_[0]\n";
    }
}


# 
# Appends specified comment line(s) to the makefile.
# To generate an inline comment, pass two parameters: 
#   1) the comment itself
#   2) the '@' symbol
# If $bGenComments is set, 3 whitespace chars will preceed the comment,
# otherwise just a new-line char will be appended.
#
sub PrintComment {
    my $string;

    if( ( @_ == 2 ) && ( $_[1] eq '@' ) ) {
	pop @_;
	print MK ( $bGenComments ) ? "   " : "\n";
    }
    if( $bGenComments ) {
	foreach $string( @_ ) {
	    print MK "# $string\n";
	}
    }
}





# ------------------------------------------------------------ #


sub AppendConsoleSection {
    my $file;
    my $ACppFile;
    my $HostOfMain;
    my $TypeOfMain;
    my $LineNo;
    my $JustHitExternC;
    my @SRCFILES = grep( /(\.c$)|(\.C$)|(\.cxx$)|(\.cpp$)/, @PROJECTDIR );

    print MK "CONSOLE=1\n";

    foreach $file( @SRCFILES ) {
	$JustHitExternC = 0;
	$ACppFile = ( $file =~ /\.c$/ ) ? 0 : 1;
	
	open( IN_FILE, "<$file" );
	while( <IN_FILE> ) {
	    chomp( $_ );
	    if( $ACppFile && /\s*extern\s+\"\s*C\s*\"/ ) {
		$JustHitExternC = 1;
		TRACE( "AppendConsoleSection[" . __LINE__ . "]: Just hit extern \"C\"" );
		next;
	    }
	    elsif( /^\s*([_a-zA-Z ]*)\s*main\s*\(/ ) {
		$TypeOfMain = $1;
		if( $JustHitExternC || !$ACppFile ) {
		    TRACE( "AppendConsoleSection[" . __LINE__ . "]: found main(). exiting..." );
		    close( IN_FILE );
		    return 1;
		}

		$HostOfMain = $file;
		$LineNo = $.;
		$LineNo-- unless( $TypeOfMain =~ /[a-zA-Z]+/ );   # $1 is a little bit too far from the pattern. BEWARE!

		TRACE( "AppendConsoleSection[" . __LINE__ . "]: $HostOfMain  ***  $TypeOfMain ***  $LineNo" );
	    }
	    elsif( $JustHitExternC ) {
		if( ! /(\#endif$|void|int)/ ) {
		    TRACE( "AppendConsoleSection[" . __LINE__ . "]: Just hit something else: $_" );
		    $JustHitExternC = 0;
		}
		else {
		    TRACE( "AppendConsoleSection[" . __LINE__ . "]: Just hit (\#endif|void|int): $_" );
		}
	    }
	}
	close( IN_FILE );
	
	if( defined $HostOfMain ) {
	    open( IN_FILE, "<$file" );
	    open( OUT_FILE, ">$file.out" );
	    while( <IN_FILE> ) {
		if( $. == $LineNo ) {
		    print OUT_FILE "\#ifdef unix\n";
		    print OUT_FILE "extern \"C\"\n";
		    print OUT_FILE "\#endif\n";
		}
		print OUT_FILE "$_";
	    }
	    close( IN_FILE );
	    close( OUT_FILE );
	    if( -z "$file.out" ) {
		Abort( "Couldn't write file $file. Please check your disk space." );
	    }
	    else {
		rename( "$file.out", "$file" );
	    }
	    return 1;
	}
    }

    PrintEx( "\nWarning:\n", $WM_BOLD );
    print "   Console application requires a main() function,\n";
    print "   but none was found in your source files.\n\n";
    return -1;
}


sub AppendMidlSection {
    my @ODLFILES = grep( /\.odl$/, @PROJECTDIR );
    my $idlfile = GetFirstFile( "idl" );
    my( $odlfile, $iidfile, $headfile, $tlbfile );

    if( @ODLFILES ) {
	print MK "TYPELIB_FILES =";
	foreach $odlfile( @ODLFILES ) {
	    $odlfile =~ s/\.odl/\.tlb/;
	    print MK " $odlfile";
	}
	print MK "\n";
    }

    if( defined( $idlfile ) ) {
	PrintComment( "MIDL related definitions" );
	print MK "MIDL_IDL    = $idlfile\n";
	$iidfile = $idlfile;
	$iidfile =~ s/\.idl/_i\.c/;
	print MK "MIDL_IID    = $iidfile\n";
	$headfile = $idlfile;
	$headfile =~ s/\.idl/\.h/;
	print MK "MIDL_HEADER = $headfile\n";
	$tlbfile = $idlfile;
	$tlbfile =~ s/\.idl/\.tlb/;
	print MK "MIDL_TLB    = $tlbfile\n\n";
    }

}


sub AppendSourceSection {
    my @sources = grep( /(\.c$)|(\.C$)|(\.cpp$)|(\.cxx$)/, @PROJECTDIR );
    my $file;
    my $not_generated_sources ;

    if (! $bUseMidlGenFiles) {

	# remove midl generated files from list (dlldata.c,*_p.c,*_i.c,*.h) 
	my $idlfile = GetFirstFile("idl") ;
	$idlfile =~ s/(\.idl)$// ;
	if($idlfile ne "") {
	    foreach $file( @sources ) {
		if( $file eq "dlldata.c" ) {
		    next ;
		}
		if( $file =~ /(${idlfile}_p\.c)$/ ) {
		    next ;
		}
		if( $file =~ /(${idlfile}_i\.c)$/ ) { 
		    next ;
		}
		push(@not_generated_sources, $file) ; 
	    }
	} 
	else {
	    foreach $file( @sources ) {
		if( $file eq "dlldata.c" ) {
		    next ;
		}
		if( $file =~ /(_p\.c)$/ ) {
		 \   next ;
		}
		if( $file =~ /(_i\.c)$/ ) { 
		    next ;
		}
		push(@not_generated_sources, $file) ;
	    }
	}
    }
    else { # use midl generated files
	@not_generated_sources = @sources;
    }

    printf MK "SOURCES = ";
    # print one source file name per line for easy editing
    foreach $file( @not_generated_sources ) {
	printf MK " \\\n\t$file";
    }
    printf MK "\n\n";
}


sub AppendLinkSection {
    my $string;
    my @LIBS = ( 
         'olepro32', 
	 'ole2ui', 
         'comdlg32', 
	 'shell32',
         'shlwapi',
         'oleaut32',
         'ole32',
         'rpcrt4',
	 'advapi32',
	 'uuid'
    );

    if( ($nSupportType & $ST_OLE) && !($nSupportType & $ST_ATL) ) {

	if ($nSupportType & $ST_MFC) {
	    print MK "# Tell MFC makefile to link with all OLE DLLs.\n";
	    print MK "MWUSE_OLE_LIBS = 1\n";
	}
	else {
	    $string = ( $nModuleType == $MT_DLL ) ? "APP_DLLFLAGS" : "APP_LDFLAGS";
	    $string .= " += ";
	    map( $string .= " \\\n\t-l$_", @LIBS );
	    $string .= "\n\n";
	    print MK $string;
	}
    }
}


sub InitGlobals {
    $nModuleType   = 0;
    $nSupportType  = 0;
    $bMfcExtDll    = undef;
    $bOcxControl   = undef;
    $bConsoleApp   = undef;
    $ModuleName    = undef;
    
    $bJustDemo     = 0;
    $bJustCompile  = 0;
    $bGenComments  = 1;
    $bRecursive    = 0;
    $bGUIMode      = 0;
    $bUseMidlGenFiles = 0;
    
    $MwClearmake   = 0;
    $MkFilename    = "makefile";
    $bSkipMkDepend = 0;
    @PROJECTDIR    = undef;
}



####################################################################

package CDspParser;


sub new {
    my $class = shift;
    my $self = {};
    Abort( "new", "Insufficient number of parameters" ) if( !@_ );
    $self->{ strDspFileName } = shift;
    bless $self;
}

sub Abort {
    my $self = shift;

    print STDERR "\n\n\aError in \e[1m" . ref( $self ) . ( ( @_ > 1 ) ? "::" . shift : ":" ); 
    print STDERR "\e[0m    ", shift, "\n\n";
    exit( -1 );
}

sub Dump {
    my $self = shift;

    print ref( $self ), ":\n";
    while( ( $key, $value ) = each %$self ) {
	print "   $key:", ' ' x ( 15 - length( $key ) ), $value, "\n";
    }
}

sub Parse {
    my $self = shift;

    my $file;
    my $cfg;
    my $incfg = 0;

    if( !open( FILE, "<" . $self->{ strDspFileName } ) ) {
	Abort( "Parse", "Could'n open open file $self->{ strDspFileName } for reading" );
    }

    while( <FILE> ) {
	chomp( $_ );
	# parse target type ( exe / dll / lib / con )
	if( !defined( $TargetType ) && /\#\s+TARGTYPE\s+.*0x(\d+)$/ ) {
	    $self->{ nTargetType } = $1;
	}
	if( !defined( $self->{ strCurConfig } ) && /^CFG=(\w+)\s+-\s+(.+)/ ) {
	    $self->{ strTargetName } = $1;
	    $self->{ strCurConfig } = $2;
	    $cfg = "\"$1 - $2\"";
	    next;
	}
	elsif( !$incfg && defined( $cfg ) ) {
	    $incfg = 1 if( /!IF\s+\"\$\(CFG\)\"\s+==\s+$cfg$/ );
	    next;
	}
	elsif( /\#\s+PROP\s+Use_MFC\s+(\d+)/ ) {
	    $nSupportType |= $ST_MFC if( $1 );
	    next;
	}
	if( /\#\s+ADD\s+CPP\s+/ ) {
	    if( /_WINDLL/ ) {
		$ModuleType = $MT_DLL;
		$MfcdllType = $DT_REG if( /_AFXDLL/ );
		$MfcdllType = $DT_EXT if( /_AFXEXT/ );
	    }
	    next;
	}
	if( /\#\s+ADD\s+LINK32/ ) {
	    
	}
	close( FILE );
	return 1;
    }
    return 0;
}
