#!/bin/env mwperl
do "$ENV{MWHOME}/lib/la/Link_Line_Atom.pl";

# For -Bdynamic and -Bstatic
use strict;
package B_Flag; @B_Flag::ISA = qw(Link_Line_Atom); {

sub new {
    my ($type, $flag) = (shift, shift);
    $flag =~ s/^-B//; # strip the flag
    my $self = Link_Line_Atom::new($type, $flag, @_);
    $self->{_b_status} = $flag;
    return $self;
}

sub get_text {
    my $self = shift;
    return "-B ".$self->{_b_status};
}

sub add_self {
    my ($self, $parser) = @_;
    $Link_Parser::B_Status = $self->{_b_status};
	return;
}
    
}
1;    

package L_Flag; @L_Flag::ISA = qw(Link_Line_Atom); {

sub new {
    my ($type, $flag) = (shift, shift);
    $flag =~ s/^-L//; # strip the flag
    my $self = Link_Line_Atom::new($type, $flag, @_);
    $self->{_L_flag} =  $flag;
    # action must be taken now so that libraries will be found.
    # rather than in add_self as in most atoms.
    push(@linker_analyzer::Lib_Path, $flag); 
    return $self;
}

sub get_text {
    my $self = shift;
    return "-L" . $self->{_L_flag};
}

}
1;

package Minus_O; @Minus_O::ISA = qw(Link_Line_Atom); {

sub new {
    my $self = Link_Line_Atom::new(@_);
    $linker_analyzer::Target = $self->{_data};
    return $self;
}

sub get_text {
    my $self = shift;
    return "-o ". $self->{_data};
}

}
1;
