use strict;
package Lib_Table;
sub new {
    my $self = bless {}, shift;
    # All existing libraries: key: stripped name, value: list of lib objects
    $self->{_present} = {};
    # Absent libraries: key: stripped name, value: 1 (no lib objects exists)
    $self->{_needed} = {};
    return $self;
}

sub saw_lib { 
    my ($self, $name, $val) = @_;
    # if it was needed it ain't any more.
    delete $self->{_needed}->{$name};
    $self->{_present}->{$name} = $val;
}

sub require_libs { 
    my $self = shift;
    foreach my $name (@_) {
	$self->{_needed}->{$name} = 1 unless $self->{_present}->{$name};
    }
}

sub get_absent { 
    my $self = shift;
    return keys %{$self->{_needed}};
}

sub delete_absent {
    my ($self, $name) = @_;
    delete $self->{_needed}->{$name};
}
    
sub get_value { 
    my ($self, $name) = @_;
    return $self->{_present}->{$name};
}
