#!/bin/env mwperl

do "$ENV{MWHOME}/lib/la/Link_Line_Atom.pl";

use strict;
package Priority; @Priority::ISA = qw(Link_Line_Atom); {
    # Static members.
    # was a priority object created?
    $Priority::priority_used = 0;
    # Default or given priority
    $Priority::Default_Priority = -2000;

sub new {
    if( $Priority::priority ) {
	# There can be only one!
	return Link_Line_Atom->new("");
    }

    my ($type, $priority, $flag) = (shift, shift, shift);
    $priority = $Priority::Default_Priority if not defined $priority;

    my $self = Link_Line_Atom::new($type, $priority, @_);
    $Priority::priority_used = 1; # mark that an object was created
	$flag = "-p" if not defined $flag;
    $self->{_flag} = $flag;
    return $self;
}

sub get_text {
    my $self = shift;

    return "" unless $linker_analyzer::Check_Priority;

    my $priority;
    if( @Link_Parser::All_Priorities ) { # saw some priorities
	my @sorted = sort {$b <=> $a} @Link_Parser::All_Priorities;
	$priority = $sorted[0] + 1; # Greatest one +1
    } else {
	# Use supplied priority
	$priority = $self->{_data};
    }
    # Make the priority known
    $linker_analyzer::Priority = $priority;

    return $self->{_flag}.$priority;
}

}
1;
