#!/bin/env mwperl

do "$ENV{MWHOME}/lib/la/Link_Line_Atom.pl";

use strict;
package U_Flag; @U_Flag::ISA = qw(Link_Line_Atom); {

sub new {
    my ($type, $flag, $parser) = (shift, shift, shift);
    
    my $self = Link_Line_Atom::new($type, $flag, @_);
    $self->{_unre} = $flag;
    
    # Update the initialy unresolved symbols
    $parser->force_unresolved($flag);
    
    # Setup platform specific u flag
    if ($ENV{MWOS} eq "sunos5") {
	$self->{_uflag} = "-Qoption ld -u,";
    }
    elsif( $ENV{MWOS} =~ /^ux1[01]$/ or $ENV{MWOS} eq "linux" ) {
	$self->{_uflag} = "-Wl,-u,";
    }
    else {
	$self->{_uflag} = "-u ";
    }

    return $self;
}

sub get_text {
    my $self = shift;
    return $self->{_uflag}.$self->{_unre};
}

sub add_self {
    my ($self, $parser) = @_;
    # This isn't redundant even though we do it in new because
    # a -u flag can be added in mid iteration.
    $parser->add_unresolved( [$self->{_unre}] );
    return;
}
    
}
1;    
