do "$ENV{'MWHOME'}/lib/common-utilities.pl";
do "$ENV{'MWHOME'}/lib/la/utils.pl";


package deffile;
{
#    sub new; constructor
#    sub generate; public
#    sub get_EXPORTS_and_LOCALS_lists; public
#    sub get_section_name; public

#    sub process_command_line; private
#    sub init; private
#    sub write_2_disk; private
#    sub read_deffile; private
#    sub merge_LOCALS_with_EXPORTS; private


# THIS FUNCTION IS IGNORED MEANWHILE!!!

# process map options
# options can be passed to deffile objects through mwdip command line or through new().
# anyway, the mwdip command line options override the new() ones.
sub process_command_line
{   
  my $self = shift;
  my ($Opt, $tmp); 
  # Empty init class members
  $self->{"lib_name"} = "";
  $self->{"in"} = "";
  $self->{"out"} = "";
  $self->{"plugin_dll"} = 0;
  $self->{"Directives"} = "";
  $self->{"cplusplus_silent"} = 0;
  @{$self->{"ARGV"}} = @_;
  # parse command line params
  while ($Opt = shift (@{$self->{"ARGV"}})) {
    if ($Opt =~ /-[DI]\S/) {
      $self->{"Directives"} .= " $Opt";
    }
    elsif ($Opt =~ /-[DI]/) {
      $tmp = shift (@{$self->{"ARGV"}});
      $self->{"Directives"} .= "$Opt $tmp";
    }
    elsif ($Opt =~ /-l/) {
      $self->{"lib_name"}=shift (@{$self->{"ARGV"}})
    }
    elsif ($Opt =~ /-o/) {
      $self->{"out"} = shift (@{$self->{"ARGV"}})
    }
    elsif ($Opt =~ /-map/) {
      $self->{"in"} = shift (@{$self->{"ARGV"}})
    }
    elsif ($Opt =~ /-plugin/) {
        $self->{"plugin_dll"} = 1;
    }
    elsif ($Opt =~ /-cplusplus/) {
        $self->{"cplusplus_silent"} = 1;
    }
    elsif ($Opt =~ /-stand_alone/) {
        $self->{"StandAlone"} = 1;
    }
  }
  # Check that we have all needed params. We allow in to be empty
  if( $self->{"lib_name"} eq "" || $self->{"out"} eq "" ) {
	  $self->mapfile_error("Invalid parameters");
  }
  if ( $linker_analyzer::Full_Trace  || $linker_analyzer::Partial_Trace ) {
    print STDERR "map file parameters:\n";
    print STDERR "Directives:  $self->{Directives}\n";
    print STDERR  "Mapfile   :  $self->{in}\n";
    print STDERR  "Library   :  $self->{lib_name}\n";
    print STDERR  "Output    :  $self->{out}\n";
  }
}

sub init
{
  my $self = shift;
  # $self->process_command_line();
  
  my $newdef = "\$self->{\"mapfile_obj\"} = new $self->{\"MWOS\"}_mapfile(\$self->{\"lib_name\"})";    
  eval $newdef; 
  if ( $@ ) {
      $self->mapfile_error("newdef: $@");
  }
}

sub mapfile_error
{
  my ($self, $msg) = @_;
  if( ! $self->{"StandAlone"} ) {
      &linker_analyzer::la_error("deffile: $msg");
  } else {
       print "deffile: Error VMW0000: $msg\n";
  }
}

sub mapfile_warning
{
  my ($self, $msg) = @_;
  if( ! $self->{"StandAlone"} ) {
       &linker_analyzer::la_warning("deffile: $msg");
  } else {
       print "deffile: Warning VMW0000: $msg\n";
  }
}

sub write_2_disk
{
  my $self = shift;
  $self->{"ExportsFromLA"} = shift;
  $self->{"LocalsFromLA"} = shift;

  my $where_wildcard = %{$self->{"Locals"}} ? "Exports" : "Locals";

  $self->merge_LOCALS_with_EXPORTS();

  open OUT, ">$self->{out}" || 
    $self->mapfile_error("Can't open out file \"$self->{out}\"");
  print OUT $self->{"mapfile_obj"}->{"Header"};
  @AllMaps = ("Exports", "Locals");
  foreach $maptype (@AllMaps) {
    if (!$self->{"mapfile_obj"}->{"Suppress_$maptype"}) {
      my $xx =  $self->{"mapfile_obj"}->{"Header_$maptype"};
      print OUT $xx, "\n" if $xx;
      foreach $line ( keys %{$self->{$maptype}} ) {
	  next if ($line =~ /::/ && $self->{"cplusplus_silent"});
          if(length ($line) > 1024 ){
	      print STDERR "Symbol length exeeds 1024, ignored:\n${line}\n";
	      next;
	  }
	  my $xx = $self->{"mapfile_obj"}->{"LinePrefix_$maptype"};
	  my $yy = $self->{"mapfile_obj"}->{"LineSuffix_$maptype"};
	  print OUT "$xx$line$yy\n";
      }
      my $zz = $self->{mapfile_obj}->{"Footer_$maptype"};
      print OUT "$zz\n" if $zz;
      print OUT $self->{"mapfile_obj"}->{"Wildcard"} if ($maptype eq $where_wildcard);
    }
  }
  print OUT $self->{"mapfile_obj"}->{"Footer"};
  close (OUT);
}

sub read_deffile
{
  my $self = shift;
  my $line, $maptype, $met_the_header = 0;
  my $OrdinalWarning = 0;
  my $AliasWarning = 0;
  my $ForwardingWarning = 0;
  my %NotSupportedKeywordWarning;

  return if( $self->{in} eq "" );
  my $prepro_cmd = "$self->{MWHOME}/bin-$self->{ARCH}/mwcpp -lang-c++ $self->{Directives} -D$self->{MWOS} $self->{in}";
  open FH,  "$prepro_cmd |" || $self->mapfile_error("Can't open $self->{in}");

  while ($line = <FH>) {
    chomp $line;
    next if ($line =~ /^\s*;|^;|^\s*#|^\s*$/) ;
    # trim leading and tailing spaces
	$line =~ s/^\s*//;
	$line =~ s/\s*$//;
    if ($line =~ /^LOCALS|^EXPORTS/)  {
      $maptype = "Locals" if $line =~ /LOCALS/ ;
      $maptype = "Exports" if $line =~ /EXPORTS/ ;
      push @{$self->{"maptype"}}, $maptype;
      $met_the_header = 1;
      next;
    }
    elsif( $line =~ /(^NAME|^LIBRARY|^DESCRIPTION|^STACKSIZE|^SECTIONS|^VERSION|^IMPORTS|^CODE)/ ) {
      # Nothing to do. Just tell user that we dont support it
      $NotSupportedKeywordWarning{$1} = 0;
      $met_the_header = 0;
    }
    elsif ($met_the_header) {
	  # This is format of line
	  # entryname[=internalname] [@ordinal[NONAME]] [DATA] [PRIVATE]
      # Split line to tokens
      my( @SplitArray );
      my( @tmpArray ) = split( /([;=@\s])/, $line );
      # now remove NULL strings
      foreach( @tmpArray )
      {
          push( @SplitArray, $_ ) if ( $_ ne "" && $_ ne " " && $_ ne "\t" );
      }
      # now iterate over tokens and see what have
      my( $Token );
      my( $EntryName ) = "";
      my( $InternalName ) = "";
      my( $MetEqualSign ) = 0;
      my( $MetOrdinal ) = 0;
      my( $HaveAlias ) = 0;
      while( $Token = shift @SplitArray )
      {
          last if( !defined($Token) || $Token eq "" || $Token eq ";" );
          if( $EntryName eq "" ) {
              # First one is EntryName
              $EntryName = $Token;
          }
          elsif( $Token eq "=" ) {
              if( $MetEqualSign ) {
                  # Error !
                  $self->mapfile_error("Error parsing def file");
                  return ;
              }
              # We have alias, print warning that we dont support this
              $InternalName = shift @SplitArray;
              if( $InternalName eq "" ) {
                  # Error !
                  $self->mapfile_error("Error parsing def file");
                  return ;
              }
              # Now handle undocumented function forwarding
              if( $InternalName =~ /(.+)\.(.+)/ ) {
                  # we have forwarded function, print warning
                  $InternalName = $2;
                  $ForwardingWarning = 1;
              } 
              $AliasWarning = 1;
              $MetEqualSign = 1;
              $HaveAlias = 1;
          }
          elsif( $Token =~ /^@/ ) {
              if( $MetOrdinal ) {
                  # Error !
                  $self->mapfile_error("Error parsing def file. More than one ordinal in line");
                  return ;
              }
              $Token =~ s/^@//;
              $Token = shift @SplitArray if( $Token eq "" ) ;
              # Now we have function's ordinal in $Token, for now do nothing with it
              $OrdinalWarning = 1;
              $MetOrdinal = 1;
              $MetEqualSign = 1; # Turn this flag on too, because we cannot have = after ordinal
          }
          elsif( $Token =~ /NONAME|DATA|PRIVATE/ ) {
              # We dont support this yet. Print warning
              $NotSupportedKeywordWarning{$Token} = 0;
              $MetOrdinal = 1; # Turn this flag on, beacuse we cannot have ordinal after these keywords
              $MetEqualSign = 1; # Turn this flag on too, because we cannot have = after these keywords
          }
          else {
              # Something wrong in def file if we got here
              $self->mapfile_warning("Error parsing def file: $line");
          }
      }  # end of while
      # We parsed current line, add symbol to our tables
      ${$self->{$maptype}}{$EntryName} = 0 if( $EntryName ne "" );
    }  # end of elsif 
  }  # end of while
  close (FH);
  # Now print warnings about unsupported features that we found in .def file
  if( ! $ENV{"MWNO_DEFFILE_WARNING"} )
  {
	  if( $OrdinalWarning ) {
    	  $self->mapfile_warning("Function ordinals are not supported in .def files");
	  }
	  if( $AliasWarning ) {
    	  $self->mapfile_warning("Function aliasing in .def files is not supported");
	  }
	  if( $ForwardingWarning ) {
    	  $self->mapfile_warning("Function forwarding in .def files is not supported");
	  }
	  foreach ( keys %NotSupportedKeywordWarning ) {
    	  $self->mapfile_warning("$_ keyword is not supported in .def files");
	  }
  }
  $self->{"already_read_deffile"} = 1;
}

sub merge_LOCALS_with_EXPORTS
{
  my $self = shift;
  if( $#{$self->{"ExportsFromLA"}} > -1) {
	foreach $sym ( @{$self->{"ExportsFromLA"}} ) {
	 if ( ! defined ${$self->{"Locals"}}{$sym} )	 {
	   ${$self->{"Exports"}}{$sym} = 0;
     }
    }
    if( %{$self->{"Locals"}} ) {
        @{$self->{"maptype"}} = qw( Exports Locals );
    } else {
	    @{$self->{"maptype"}} = qw( Exports );
    }
  }
 if( $#{$self->{"LocalsFromLA"}} > -1) {
	foreach $sym ( @{$self->{"LocalsFromLA"}} ) {
	 if ( ! defined ${$self->{"Exports"}}{$sym} )	 {
	   ${$self->{"Locals"}}{$sym} = 0;
     }
    }
    if( %{$self->{"Exports"}} ) {
        @{$self->{"maptype"}} = qw( Exports Locals );
    } else {
        @{$self->{"maptype"}} = qw( Locals );
    }
  }

 # export some MainWin internal symbols automatically   
  $self->add_auto_exports();
}

# Exports some internal mainwin symbols
sub add_auto_exports
{
  my ($self) = shift;
  my ($path, $base, $ext, $Target_Stripped );
 # export some MainWin internal symbols automatically   
    $_ = $self->{"lib_name"};

    &::split_path($_, \$path, \$base, \$ext);
    $Target_Stripped .= $base . ".$ext";
    if ($Target_Stripped =~ /^lib(.*)\.s.$/) {
	$Target_Stripped = $1;
    }
    #  export of  DependencyNode ...
    my $safe_name = &::calc_safe_name($Target_Stripped);
    $DependNode = "Mw___" . $safe_name . "_DependancyNode";
    ${$self->{Exports}}{$DependNode} = 0;
    push( @{$self->{ExportsFromLA}}, $DependNode );
    delete ${$self->{Locals}}{$DependNode};

    $KeepThese = "Mw___" . $safe_name . "_keep_these";
    ${$self->{Exports}}{$KeepThese} = 0;
	push( @{$self->{ExportsFromLA}}, $KeepThese);
	delete ${$self->{Locals}}{$KeepThese};

    # We added exported symbol, Check if Exports section exists
	# And add it if it is not exist
	my( $maptype );
	my( $HaveExports ) = 0;
	foreach $maptype (@{$self->{maptype}}) {
        $HaveExports = 1 if( $maptype eq "Exports" ) ;
	}
	push( @{$self->{maptype}}, "Exports") if( ! $HaveExports ) ;
    # export _shlinit for hpux
    if ( $self->{"MWOS"} eq "ux10" || $self->{"MWOS"} eq "ux11" ) {
        ${$self->{Exports}}{"_shlInit"} = 0;
        push( @{$self->{ExportsFromLA}}, "_shlInit" );
        delete ${$self->{Locals}}{"_shlInit"};
    }

    # Export mainwin_init in case of plugin DLL
    if ( $self->{"plugin_dll"} == 1 ) {
        ${$self->{Exports}}{"mainwin_init"} = 0;
        push( @{$self->{ExportsFromLA}}, "mainwin_init" );
        delete ${$self->{Locals}}{"mainwin_init"};
    }
}

# la should compare the section_name to the original name, and if they are not 
# the same, it should convert the map command in the command line
sub get_section_name
{ 
  my ($self) = @_;

  return ${$self->{"maptype"}}[0];
}

# used by la to get the initial exports list, in order to force 
# unresolved symbols at link time
sub get_EXPORTS_and_LOCALS_lists
{
  my ($self, $exports, $locals) = @_;

  if ( ! $self->{"already_read_deffile"} ) {
      $self->read_deffile();
  }
  %$exports = %{$self->{"Exports"}};
  %$locals  = %{$self->{"Locals"}};
}

# do the job
sub generate
{
  my $self = shift;
  my ($exports, $locals) = @_;

  if ( ! $self->{"already_read_deffile"} ) {
    $self->read_deffile();
  }
  $self->write_2_disk($exports, $locals);
  if ( $linker_analyzer::debug ) {
      print STDERR ">>> mapfile was successfully generated.\n";
  }
  return $linker_analyzer::True;
}

sub new
{
  my ($class) = shift;
  my $self = bless {}, $class;

  $self->{"StandAlone"} = 0;
  $self->process_command_line(@_);

  @{$self->{"maptype"}} = ();
  %{$self->{"Locals"}} = ();
  %{$self->{"Exports"}} = ();
  $self->{"MWHOME"} = $ENV{MWHOME};
  $self->{"ARCH"} = $ENV{MWARCH_OS};
  $self->{"MWOS"} = $ENV{MWCONFIG_NAME};
  $self->{"already_read_deffile"} = 0;
  $self->{"mapfile_obj"} = {};

  $self->init();

  return $self;
}

} # end of package deffile



package mapfile;
{
  # sub new; ctor
  
  sub new
  {   
    my ($class) = shift;
    my $self = bless {}, $class;
 
    $self->{"lib_name"} = shift;
    $self->{"Header"} = "";
    $self->{"Footer"} = "";
    $self->{"Header_Locals"} = "";
    $self->{"Header_Exports"} = "";
    $self->{"Footer_Locals"} = "";
    $self->{"Footer_Exports"} = "";
    $self->{"LinePrefix_Locals"}  = "";
    $self->{"LineSuffix_Locals"}   = "";
    $self->{"LinePrefix_Exports"}  = "";
    $self->{"LineSuffix_Exports"}   = ""; 
    $self->{"Suppress_Exports"} = 0;
    $self->{"Suppress_Locals"} = 0;
    $self->{"Wildcard"} = "";
    return $self;
  }
}

package sunos5_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;

    $self->{"Header"}         = "$self->{lib_name}\n" . '{' . "\n";
    $self->{"Footer"}         = "};\n";
    $self->{"Header_Locals"}  =  "local:";
    $self->{"Header_Exports"} =  "global:";
    $self->{"LineSuffix_Locals"}  = ";";
    $self->{"LineSuffix_Exports"} = ";";
    $self->{"Wildcard"} = "*;\n";
    return $self;
  }
}

# mapfile on linux is EXACTLY like on sun.
package linux_mapfile; @ISA = qw(sunos5_mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = sunos5_mapfile::new(@_);
    my ($class) = shift;

    return $self;
  }
}

package aix4_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    # $self->{"LineSuffix_Locals"}   = " list";
    $self->{"Suppress_Locals"} = 1;
    return $self;
  }
}


package osf1v4_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    $self->{"Header_Locals"} = "-non_hidden";
    $self->{"Header_Exports"} = "-hidden";
    $self->{"LinePrefix_Locals"}  = "-hidden_symbol ";
    $self->{"LinePrefix_Exports"}  = "-exported_symbol ";
    return $self;
  }
}

package irix6_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    return $self;
  }
}

package ux10_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    $self->{"LinePrefix_Locals"}  = "-h ";
    $self->{"LinePrefix_Exports"}  = "+e ";
    return $self;
  }
}

package ux11_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    $self->{"LinePrefix_Locals"}  = "-h ";
    $self->{"LinePrefix_Exports"}  = "+e ";
    return $self;
  }
}

package ia64_ux11_mapfile; @ISA = qw(mapfile);
{
  # sub new; ctor
  sub new
  {
    my $self = mapfile::new(@_);
    my ($class) = shift;
    $self->{"LinePrefix_Locals"}  = "-h ";
    $self->{"LinePrefix_Exports"}  = "+e ";
    return $self;
  }
}
