
package pragma;
{
#  sub do; public
#  sub new; ctor
#  sub pragma_comment_lib; private
#  sub pragma_rawentry; private

  sub do
  {
    my $self = shift;
    $self->{"text"} = shift;

    $self->{"text"} =~ /__mw_link_(\d+)_(.*?)_(\d+)_/;
    my $rest = $';
    if ( $rest =~ /^lib_/ )
    {
       $self->{"lib"} = $'; 
       return $self->pragma_comment_lib();
    }
    if ( $rest =~ /^rawentry_/ )
    {
       $self->{"rawentry"} = $';
       return $self->pragma_rawentry();
    }

    return $linker_analyzer::False;
  }

# there are two ways to pass the raw entry enrtyname to dip. 
# one is the -rawentry flag, the other is this pragma.
# if both are supplied and are different, dip will issue a warning and 
# "believe" la
  sub pragma_rawentry
  {
    my $self = shift;
    $linker_analyzer::Raw_Entry =  $self->{"rawentry"};
    if ($Full_Trace) {
      print STDERR "la discovered RAWENTRY=$linker_analyzer::Raw_Entry\n";
    }
    return $linker_analyzer::True;
  }

  sub pragma_comment_lib
  {
    my ($self) = @_;
    my $libfile, $str = "";

    $str = &linker_analyzer::uncalc_safe_name( $self->{"lib"} );

    if ( $str =~ /(.*)\.lib/ ) { $str = $1; }
    if( $Full_Trace ) {
	local $, = " ";
	print STDERR "> pragma comment(lib $str)\n";
    }
    if ( ! defined $linker_analyzer::Nodef_Lib{$str} &&
	! $linker_analyzer::Nodef_Libs ) {
      &linker_analyzer::locate_lib($str);
    }
    elsif ( $linker_analyzer::Full_Trace ) {
	print STDERR 
	    "ignoring pragma comment(lib, $str) because of nodeflib\n";
    }
    return $linker_analyzer::True;
  }

  sub new
  {
    my ($class) = shift;
    my $self = bless {}, $class;
    $Full_Trace = $linker_analyzer::Full_Trace ; 
    return $self;
  }

}

