
sub split_path
{
   my ($in, $path, $base, $ext) = @_;

   $$path = $$base = $$ext = "";
   if ( $in =~ /(.*\/)(.*)/ ) { $$path = $1; $$base = $2; }
   else { $$base = $in; }
   if ( $$path =~ /(.+)\/$/ ) { $$path = $1; }
   if ( $$base =~ /(.*)\.(.*)/ ) { $$base = $1; $$ext = $2; }
}

sub list_contains
{
   my ($list, $member) = @_;
   my %h; 

   @h{@$list} = @$list; 
   return ( defined $h{$member} );
}

   
sub max
{
   my ($x, $y, $result) = @_;
   if ( ! defined $x ) {
      if ( ! defined $y ) { 
         return $False; 
      }
      else { 
         $$result = $y; return $True; 
      }
   }
   elsif ( ! defined $y ) {
      $$result = $x; return $True;
   }
   else {
      my @unsorted = ($x, $y);
      my @sorted = sort {$b <=> $a } @unsorted;
      $$result = $sorted[0];
      return $True;
   }
}  

sub Execute {
    my $ret;

    if ($linker_analyzer::Partial_Trace) {
	$ret = ShowAndExecuteCommand(@_);
    } else {
	$ret = SilentExecuteCommand(@_);
    }
    return $ret;
}


# Same as ExecuteCommandNoExit, doesn't print error message
sub SilentExecuteCommandNoExit {
    local(@command) = @_;
    # remove empty params from command
    local @new_cmd = grep($_, @command);
    local($stat) = system(@new_cmd);
    return $stat;
}

sub ExecuteNoExit {
    my $ret;

	if ($linker_analyzer::Partial_Trace) {
		$ret = ShowAndExecuteCommandNoExit(@_);
        } else {
		$ret = SilentExecuteCommandNoExit (@_);
	 }

	return $ret;
}



sub list_make_unique
{  
    my ($list) = shift;
    my (%h, @t);

    foreach $e ( @$list ) {
	if ( not defined $h{$e} ) {
	    $h{$e} = "";
	    push(@t, $e);
	}
    }
    @$list = @t;
}

sub _flocate
{
    my ($file, $noisy, $nocase) = (shift, shift, shift);
    my $ff;
    if ( ! $nocase ) { 
        if ( -e $file ) {
            return $file;
	}
	else {
	    return "";
	};
    }

    my $dir = "";

    $file =~ tr/\\/\//;
    if ( $file =~ /\/$/ ) { $file = $`; }
    return _locate(\$dir, \$file);
}

sub _locate
{
    my ($dir, $file) = (shift, shift);
    my $sub_dir = "";
    my $new_file = "";
    
    if ( substr($$file, 0, 1) eq "/" ) {
	$$dir = "/";
	$$file  = substr($$file, 1);
    }

    if ( $$file eq "" ) {
	return $$dir;
    }

    if ( $$file =~ /\// ) {
	$sub_dir = $`;
	$new_file = $';
    }
    else {
	$sub_dir = $$file;
    }

    if ( $$dir eq "" ) { $$dir = "."; }

    opendir(DIR, $$dir);
    my $lc_dir = lc($sub_dir);
    foreach ( readdir(DIR) ) {
	if ( lc($_) eq $lc_dir ) {
	    closedir(DIR);
	    if ( $$dir =~ /\/$/ ) {
		$$dir .= $_;
	    }
	    else {
		$$dir .= "/$_";
	    }
	    $$file = $new_file;
	    return _locate($dir, $file);
	}
    }
    closedir(DIR);
    return "";
}

