# This is a -*- perl -*- script
##########################################################################
#    This program is the CONFIDENTIAL and PROPRIETARY property
#    of Mainsoft(R) Corporation. Any unauthorized use, reproduction 
#    or transfer of this computer program is strictly prohibited.
#
#    Copyright (c) 1991-1998 Mainsoft Corporation.
#    This is an unpublished work, and is subject to limited distribution
#    and restricted disclosure only. ALL RIGHTS RESERVED.
#
##########################################################################

my $bAutoLoad = 0;


if( $ARGV[0] eq "-autoload" ) {
    shift @ARGV;
    $bAutoLoad = 1;
    if( !@ARGV ) {
	printf "\nUsage: mwtounix <file1> ... <fileN>\n";
	printf "Translates DOS <CR-LF> into unix <LF>\n";
	printf "and removes <CTRL-Z> from the end of file.\n\n";
	exit -1;
    }
    ToUnix( @ARGV );
}


sub AUTOLOAD {
    print "      Unknown function $AUTOLOAD called at line ".__LINE__.".\n";
    print "      Defaulting to ToUnix.\n";
    ToUnix( @_ );
}


#
# convert every file to unix format changing <cr><lf> to <lf> and
# pc character set to iso character set
#
# now we have suppressed the character set conversion
# because, we have found that
# most of the software was already using iso character set
#
sub ToUnix {    
    foreach $file( @_ ) {
	next if ($file eq "-no-usage-message");
	
	if (!(-l $file) && (-f $file) && (!-z $file)) {
	    print STDOUT "Doing dos2unix on $file\n" if $bAutoLoad;
	    open(INFILE, "<$file");
	    open(OUTFILE, ">${file}.out");
	    while (<INFILE>) {	
		s/\r\n$//;
		s/\n$//;
		# also remove  at the end of file
		s/\032//;
		print OUTFILE $_,"\n";
	    }
	    close(INFILE);
	    close(OUTFILE);
	    if( ! -z "$file.out" ) {
		if(0 == system("cmp -s $file $file.out > /dev/null")) {
			unlink("$file.out") ;
		}
		else {
			rename( "$file.out", "$file" );
		}
	    }
	    else {
		print STDERR "Conversion failed: couldn't create file of size " . ( -s $file ) . ". Please check your disk space.\n\n";
		unlink( "$file.out" );
	    }
	}
    }
}


1;  # to satisfy the 'require' function
