# This is a -*- perl -*- script

#########################################################################
#                                                                       #
#  This program is the CONFIDENTIAL and PROPRIETARY property            #
#  of Mainsoft(R) Corporation. Any unauthorized use, reproduction       #
#  or transfer of this computer program is strictly prohibited.         #
#                                                                       #
#  Copyright (c) 1991-1998 Mainsoft Corporation.                        #
#  This is an unpublished work, and is subject to limited distribution  #
#  and restricted disclosure only. ALL RIGHTS RESERVED.                 #
#                                                                       #
#########################################################################


$CmdLine = "$ENV{MWHOME}/lib-$ENV{MWCONFIG_NAME}/xde";
$SIG{ INT } = \&IntHandler;

if( !-f $CmdLine ) {
    print "\nUnable to locate '$CmdLine'\n\n";
    exit -1;
}

if( "true" eq "\L$ENV{MWXDE_CLOCK}" ) {
    RunWithClock();
}
else {
    print "Loading MWXDE. Please wait...\n";
    print "\nCouldn't launch MWXDE\n\n" unless RunMWXDE();
}



sub RunWithClock {
    my @clock = ( '-', '\\', '|', '/' );
    my $count = 0;
    
    $pid = fork;
    if( $pid ) {
	$SIG{ TERM } = \&TermHandler;
	print "\n";
	while( 1 ) {
	    print "\eM\e[D($clock[$count++]) Loading MWXDE. Please wait...\n";
	    select( undef, undef, undef, 0.1 );
	    $count %= 4;
	}
    }
    elsif( defined $pid ) {
	$CmdLine .= " -ntfp " . getppid();
	if( !RunMWXDE() ) {
	    kill( TERM, getppid() );
	    print "\eM\e[M\e[D\nCouldn't launch MWXDE.\n\n";
	}
    }
    else {
	print "\nUnable to fork\n\n";
    }
}
 
 
sub RunMWXDE {
    $CmdLine .= " -defs @ARGV" if @ARGV;
 
    $ENV{ MWDEBUG } = 0;
    system( "mwuseconfig" );
    return exec( $CmdLine );
}


sub TermHandler { 
    print "\eM\e[M"; 
    exit;
}

# Since dterm and xterm behave differently, the 'delete-line'
# and 'cursor-left' escape sequences must be doubled.
sub IntHandler {
    print "\eM\e[M\e[M\e[D\e[D<CTRL-C> signaled. Exiting...\n\n";
    exit;
}

